<?php
	require_once(PHPGW_SERVER_ROOT.SEP.'workflow'.SEP.'inc'.SEP.'natural'.SEP.'class.natural.php');

	/**
	* Mainframe connection to workflow
	* @author Everton Flvio Rufino Sera
	* @package Workflow
	* @subpackage local
	* @license http://www.gnu.org/copyleft/gpl.html GPL
	**/

	class wf_natural extends Natural
	{

		function __construct()
		{
			parent::Natural();

			$natconf = array(
						'mainframe_ip'			=> '',
						'mainframe_port'		=> '',
						'mainframe_key'			=> '',
						'mainframe_password'	=> '',
						'mainframe_environment'	=> ''
			);

			$nat_conf_values = $GLOBALS['workflow']['wf_runtime']->getConfigValues($natconf);

			$this->setIPAddress($nat_conf_values['mainframe_ip']);
			$this->setServerPort($nat_conf_values['mainframe_port']);
			$this->setKey($nat_conf_values['mainframe_key']);
			$this->setPassword($nat_conf_values['mainframe_password']);
			$this->setApplication($nat_conf_values['mainframe_environment']);
		}

		/**
		 * Method to configure the access to mainframe
		 * This method MUST be called before using execute method, else 'false' will be returned
		 *
		 * Only the first and second param are mandatory.
		 *
		 * @param String $subProgram - Name of sub-program
		 * @param String $inputParameter - Input parameters to sub-program
		 *
		 * @param String $ip - IP Address of Mainfram
		 * @param int $port - ServerPort to access the mainframe
		 * @param String $key - Access key (user)
		 * @param String $password - Key (user) password
		 * @param char $environment - Application environment access 'D' (development) or 'P' (production)

		 */

		public function configure($obj)
		{
			$this->obj = $obj;

			$this->initialize($obj->name);

			if ($obj->server != NULL){
				$this->setIPAddress($obj->server);
			}
			if ($obj->port != NULL){
				$this->setServerPort($obj->port);
			}
			if ($obj->key != NULL){
				$this->setKey($obj->key);
			}
			if ($obj->password != NULL){
				$this->setPassword($obj->password);
			}
			if ($obj->environment != NULL){
				$this->setApplication($obj->environment);
			}
			if ($obj->logon != NULL){
				$this->setLogon($obj->logon);
			}
			if ($obj->system != NULL){
				$this->setSystem($obj->system);
			}
			if ($obj->rc != NULL){
				$this->setRC($obj->rc);
			}
		}

		/*

		public function configure($subProgram, $inputParameter, $ip = NULL, $port = NULL,
										$key = NULL, $password = NULL, $environment = NULL, $logon = NULL, $system = NULL, $rc = NULL)
		{
			$this->initialize($subProgram, $inputParameter);

			if ($ip != NULL){
				$this->setIPAddress($ip);
			}
			if ($port != NULL){
				$this->setServerPort($port);
			}
			if ($key != NULL){
				$this->setKey($key);
			}
			if ($password != NULL){
				$this->setPassword($password);
			}
			if ($environment != NULL){
				$this->setApplication($environment);
			}
			if ($logon != NULL){
				$this->setLogon($logon);
			}
			if ($system != NULL){
				$this->setSystem($system);
			}
			if ($rc != NULL){
				$this->setRC($rc);
			}

		}

		 */

		/**
		 * Access and retrieve data from mainframe
		 * @return bool
		 */
		public function execute($inputParams = "")
		{
			return parent::execute($inputParams);
		}
	}
?>
